function cargar_imag
% Esta funcion permite buscar una imagen monocromatica almecenada
% en alguna unidad de la pc, para posteriormente cargarla al 
% Display Grafico.

[nombre,ruta] = uigetfile('*bmp','seleccione una imagen');
nombre_completo = sprintf('%s%s',ruta,nombre);
M = imread(nombre_completo);
N = ~M;

  delete(instrfind);
  s = serial('com5');
  set(s,'BaudRate',57600,'parity','none','DataBits',8,'StopBits',1);
  fopen(s)        
for r = [0,8,16]
    for c = 1:24
        octeto = N(r+(1:8),c);
        dato = power(2,0:1:7)*octeto;
        fwrite(s,dato);
    end
end
  fclose(s);
  delete(s);
