unsigned short imag[24] =  {0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0};
unsigned short imag2[24] = {0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0};
unsigned short imag3[24] = {0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0};

unsigned short x = 0, x1 = 0, x2, dato, cnt = 0;

void Iniciar_I2C()
{
  SSPCON = 0B00110110;
  SSPCON2.GCEN = 0;
  SSPCON2.SEN = 0;
  SSPSTAT.SMP = 0;
  SSPSTAT.CKE = 0;
  SSPADD = 2;
  TRISC.F3 = 1;
  TRISC.F4 = 1;

  PIE1.SSPIE = 1;
  INTCON.PEIE = 1;
  INTCON.GIE = 1;
  PIR1.SSPIF = 0;
}

void reloj()
{
   PORTE.F1 = 1;
   Delay_us(1);
   PORTE.F1 = 0;
}

void barrido()
{
   PORTE.F0 = 1;
   Delay_us(1);
   reloj();
   PORTE.F0 = 0;
}

void interrupt()
{
   dato = SSPBUF;
   
     if (x1 == 72)
     {
        x = 0;
        x1 = 0;
     }
     if (x1 == 0 | x1 == 24 | x1 == 48)
        x2 = 0;
        
     if (x>0)
     {
        if (x1 < 24)
           imag[x2] = dato;
        if (x1 > 23 & x1 < 48 )
           imag2[x2] = dato;
        if (x1 > 47)
           imag3[x2] = dato;
           
        x1 ++;
        x2 ++;
     }
   x ++;
   
   PIR1.SSPIF = 0;
}

void main()
{
  Iniciar_I2C();
  ADCON1 = 6;
  TRISA = 0; TRISB = 0; TRISD = 0; TRISE = 0;
  PORTA = 0; PORTB = 0; PORTD = 0; PORTE = 0;

  while(1)
  {
     if (SSPSTAT.P == 1)
     dato = SSPBUF;

     if (cnt == 24)
     {
       barrido();
       cnt = 0;
     }

     PORTB = imag[cnt];
     PORTD = imag2[cnt];
     PORTA = imag3[cnt];
     Delay_us(800);
     PORTA = 0;
     PORTB = 0;
     PORTD = 0;
     reloj();
     cnt++;
  }
}